<template>
  <div v-if="showForm" style="max-height: 80%">
    <createFormular
      @formsubmittedEvent = "loadWorld()"
    />
     <button @click="closePopup()"> Disgard </button>
  </div>
  <div v-if="showDeleteForm">
    <deleteForm
    :close-popup="() => closePopup()"
    />
  </div>
  <div v-if="showLoadForm">
    <loadForm 
      :close-popup="() => closePopup()" 
      @mapChosenEvent = "loadWorld()"
      />
  </div>
  <div v-show="!showForm">
    <button	@click="showForm = !showForm;"> Create World </button>
    <button @click="showLoadForm=true"> Load World </button>
    <button @click="showDeleteForm=true"> Delete World </button>
    <button @click="save()">Save</button>
    <button @click="zoomin()">zoom in</button>
    <button @click="zoomout()">zoom out</button>
    <button @click="toggleSelect()" :class="{selectmode : isSelect}">Select several planets</button> 
    <button @click="deleteSelected()">Delete selected Planets</button>
    <div>
      <canvas ref="space" id="space" width=100 height=100 class="space"></canvas>
      <canvas 
      @click="handleClick($event)"
      ref="planets" 
      id="planets" 
      width=500 
      height=500 
      class="planets"></canvas>
    </div>
  </div>
</template>

<script lang="ts">
import createFormular from './create-form.vue'
import loadForm from './load-form.vue';
import deleteForm from './delete-form.vue'
import store from '@/store/index'
import type { World, Planet, Resource } from '@/components/mapfiletype'



export default {
    components:{
      createFormular,
      loadForm,
      deleteForm,
    },
    data(){
      return{
       green: "#6de86b",
       yellow: "#cbd41e",
       red: "#c20e0e",
       blue:"#0000FF",
       isSelect: false,
       showForm: false,
       showLoadForm: false,
       showDeleteForm: false,
       planetradius: 30, 
       selected: []
      }
    },
    mounted() {
      
      const canvas = document.getElementById("space");
      if (canvas instanceof HTMLCanvasElement) {
        const context = canvas.getContext("2d");
  
        if (context) {
          canvas.width=window.innerWidth/1.1;
          canvas.height=window.innerHeight/1.24;
          context.fillStyle = "#0b0c18";
          context.fillRect(0, 0, canvas.width, canvas.height);
        }
      }

    },
    computed:{
            gameDataFromStore() {
                return this.$store.state.gameData;
            }
        },
    methods: {
        closePopup(){
          this.showLoadForm =false;
          this.showDeleteForm = false;
          this.showForm = false;
        },
        loadSpaceContext(){
          const canvas = document.getElementById("space");
          if (canvas instanceof HTMLCanvasElement) {
          const context = canvas.getContext("2d");
            if (context) {
              return context
            }else{
              return false;
            }
          }
        },
        loadPlanetContext(){
          const canvas = document.getElementById("planets");
          if (canvas instanceof HTMLCanvasElement) {
          const context = canvas.getContext("2d");
            if (context) {
              return context
            }else{
              return false;
            }
          }
        },
        loadWorld(){ 
          this.showLoadForm = false;
          this.showForm = false;
          this.showDeleteForm = false;
          const data:World = this.gameDataFromStore;
          if(data == null){
            return;
          }
          const context = this.loadPlanetContext();
          let maxX = 0;
          let maxY = 0;
          
          for(let planet of data.planets){
            if(planet.x>maxX)
              maxX = planet.x;
            if(planet.y>maxY)
              maxY = planet.y
          }
          context.clearRect(0,0,maxX, maxY);
          
          const canvas = document.getElementById("planets");
          const space = document.getElementById("space");
          if (canvas instanceof HTMLCanvasElement && space instanceof HTMLCanvasElement) {
            const newHeight = (maxY+1) * (2*this.planetradius);
            const newWidth=(maxX+1) * (2*this.planetradius);
            canvas.width=newWidth;
            canvas.height=newHeight;
            space.width=newWidth;
            space.height=newHeight
            space.getContext("2d").fillStyle = "#0b0c18";
            space.getContext("2d").fillRect(0, 0, canvas.width, canvas.height);
            
          }
          if (context) {
            for(let planet of data.planets){
              if(planet.resource!=null)
                this.addCricle(planet.x, planet.y, planet.movementDifficulty, planet.resource);
              else 
                this.addCricle(planet.x, planet.y, planet.movementDifficulty, null);
            }
          }
          
        },
        addCricle(x: number, y:number, area:number, rescource: Resource){
          const context = this.loadPlanetContext();
          if(context){
            x=x*(this.planetradius*2)+this.planetradius;
            y=y*(this.planetradius*2)+this.planetradius;
            context.beginPath();
            context.arc(x, y, this.planetradius, 0, Math.PI*2, true);
            switch(area) {
              case 1: context.fillStyle = this.green;
                break;
              case 2: context.fillStyle = this.yellow;
                break;
              case 3: context.fillStyle = this.red;
            }
            context.fill();
            context.stroke();
            
            if(rescource == null)
              return;
            if(rescource && this.planetradius>=15){
              context.strokeText(rescource.resourceType, x-15, y);
              context.strokeText(rescource.maxAmount + "", x-15, y+15);
            }
            
          }
        },
        save(){

          this.$store.dispatch('saveThisGameworld');
          this.loadWorld();
        },
        getPlanetIdbyCoordinates(x:number, y:number): number{
          const data:World = this.gameDataFromStore;
          if(data == null){
            return 0;
          }
          for(let planet of data.planets){
              if(planet.x == x && planet.y == y){
                return planet.id;
              }
            }
          return 0; 
        },
        getXByID( id:number):number{
          const data:World = this.gameDataFromStore;
          if(data == null){
            return 0;
          }
          for(let planet of data.planets){
              if(planet.id == id){
                return planet.x;
              }
            }
          return 0;
        },
        getYByID( id:number):number{
          const data:World = this.gameDataFromStore;
          if(data == null){
            return 0;
          }
          for(let planet of data.planets){
              if(planet.id == id){
                return planet.y;
              }
            }
          return 0;
        },
        handleClick(e){
          const left=this.$refs.planets.getBoundingClientRect().left;
          const height=this.$refs.planets.getBoundingClientRect().top;

          let x = Math.trunc((e.clientX-left)/(2*this.planetradius));
          let y = Math.trunc((e.clientY-height)/(2*this.planetradius));

          if(this.isSelect){
            const temp = this.getPlanetIdbyCoordinates(x,y)
            if(temp === 0){
              return;
            }
            if(this.selected.includes(temp, 0)){
              this.selected = this.selected.filter((planet) => planet !==temp)
              this.loadWorld();
              for(let select of this.selected){
                const x = this.getXByID(select);
                const y = this.getYByID(select);
                this.drawSelectedByCoordinates(x,y);
              }
            }else{
              this.selected.push(temp);
              this.drawSelectedByCoordinates(x,y);
            }
          }
        },
        drawSelectedByCoordinates(x: number, y:number){
          const context = this.loadPlanetContext();
              if(context){
                x=x*(this.planetradius*2)+this.planetradius;
                y=y*(this.planetradius*2)+this.planetradius;
                context.globalAlpha=0.5;
                context.beginPath();
                context.arc(x, y, this.planetradius, 0, Math.PI*2, true);
                context.fillStyle = this.blue;
                context.fill();
                context.stroke();
              }  
        },
        deleteSelected(){
          const data:World = this.gameDataFromStore;
          if(data == null){
            console.log("DATA IS NULL COORDINATES")
            return;
          }
          for(let select of this.selected){
              data.planets = data.planets.filter((planet) => planet.id !== select)
          }
          this.$store.commit('setGameData', data)
          this.isSelect = false;
          this.loadWorld();
        },
        zoomin(){
          const factor = 1.5;
          this.planetradius=this.planetradius*factor;
          if(this.planetradius>=151)
            this.planetradius=this.planetradius/factor;
          this.loadWorld();
        },
        zoomout(){
          const factor = 1.5;
          this.planetradius=this.planetradius/factor;
          if(this.planetradius<=8)
            this.planetradius=this.planetradius*factor;
          this.loadWorld();
        },
        toggleSelect(){
          this.loadWorld();
          this.isSelect=!(this.isSelect);
          this.selected = [];
        }
      },
}
</script>

<style>
canvas{
  position: absolute;
  left:0;
  right: 0;
  margin: auto;
}

.space{
  position: absolute;
  left:0;
  right: 0;
  margin: auto;
}
.planets{
  position: absolute;
  left:0;
  right: 0;
  margin: auto;
  overflow: scroll;
}

.selectmode{
  background-color: aqua;
  color:brown;
}

.modal {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background: rgba(0, 0, 0, 0.5);
  color: aliceblue;
  display: flex;
  justify-content: center;
  align-items: center;
}

.modal button {
  position: absolute;
  top: 10px;
  right: 10px;
}
</style>